
% calculate the FM index of GHRFSOM

function FM = FGMTT_FM(Pm,Child,Layer,CorSet,Links,XLable)

% initialization
for i=1:Pm.TotalNumNode
    CorSet{i}=double(CorSet{i});
end
NumLeaf=0;
for i=1:Pm.TotalNumNode
    NumLeaf=NumLeaf+length(find(Child{i}==0)); % count the total number of leaf nodes
end
NumMerge=NumLeaf-Pm.NumClass; % count how many merging is needed
CheckUpLayer=1; 
ThisLayer=max(Layer); % go to the bottom layer

% find the cutting layer and cutting point
while CheckUpLayer==1
    NodeList=find(Layer==ThisLayer);
    NumLinks=0;
    for i=1:length(NodeList)
        NumLinks=NumLinks+length(Links{NodeList(i)}(:,1)); % count how many mergings can this layer offer
    end
    if NumMerge-NumLinks>0 % if the mergings in this layer cannot reach the required merging times, go to upper layer
        ThisLayer=ThisLayer-1;
        NumMerge=NumMerge-NumLinks;
    else % if the mergings in this layer can reach the required merging times, 
        CheckUpLayer=0;
        for i=1:NumMerge
            FoundThat=0; % FoundThat means if find out the ith merging on ThisN in present layer
            a=1;
            while FoundThat==0
                ThisN=NodeList(a);
                MergeLct=find(Links{ThisN}(:,3)==i);
                if isempty(MergeLct)==1
                    a=a+1;
                else
                    FoundThat=1;
                end
            end
            NumSubNodes=length(Child{ThisN});
            CorSet{ThisN}(NumSubNodes+MergeLct,:)=...
                CorSet{ThisN}(Links{ThisN}(MergeLct,1),:)+...
                CorSet{ThisN}(Links{ThisN}(MergeLct,2),:);
            CorSet{ThisN}(Links{ThisN}(MergeLct,1),:)=inf;
            CorSet{ThisN}(Links{ThisN}(MergeLct,2),:)=inf;
        end
    end
end

% extract the produced label of the clustering result
PLable=zeros(Pm.Xlth,1);
NodeLth=length(NodeList);
c=0;
for i=1:NodeLth
    GroupList=find(CorSet{NodeList(i)}(:,1)~=inf);
    if isempty(GroupList)==0
        for j=1:length(GroupList)
            c=c+1;
            PLable(CorSet{NodeList(i)}(GroupList(j),:)==1)=c;
        end
    end
end

% compute the FM index
Combs=perms(1:Pm.NumClass);
for i=1:length(Combs(:,1))
    for j=1:Pm.NumClass
        TP(j)=length(find(PLable(XLable==j)==Combs(i,j)));
        FP(j)=length(find(PLable==Combs(i,j)))-TP(j);
        FN(j)=length(find(XLable==j))-TP(j);
    end
    fm(i)=sqrt(sum(TP)^2/((sum(TP)+sum(FP))*(sum(TP)+sum(FN))));
end
FM=max(fm);
