
% This script excute hierarchical clustering using our approach. 
% Corresponding hierarchical accuracy is calculated.

clear;
clc;

load seed;
X=seed;
[Pm.Xlth,Pm.Xwd]=size(X);
Pm.NumClass=length(unique(X(:,Pm.Xwd)));
Pm.Xwd=Pm.Xwd-1;

Fold=10;
HAcc=zeros(Fold,1);
FM=zeros(Fold,1);

for m=1:4
    rand('seed',11);
    linkage=m % display the present linkage
    for f=1:Fold
        RandList=randperm(Pm.Xlth,Pm.Xlth);
        X=X(RandList,:);% randomly initialize the dataset
        [HAcc(f), FM(f)] = GMTTMain(X,1,m,Pm); 
        % first input: data set X
        % second input: 1 stands for max-min normalization, 2 stands for mean-standard normalization
        % third input: 1-3 stands for single/avearge/complete linkage, 4 stands for our density linkage
        fold=f % display the present fold
    end
    O_AccMean(1,m)=mean(HAcc);
    O_FMMean(1,m)=mean(FM);
end
O_AccMean
O_FMMean






