
% when the hierarchy structure needs to grow, train the new deeper layer
% with Pm.k new neurons.

function [Node,CorSet,NumNode] = TrainNodes(Data,DataLct,Pm)
%% preprocessing
[SubXlth,~]=size(Data);
if SubXlth/(Pm.B-1)>Pm.UpLimit
    NumNode=Pm.B;
else
    NumNode=ceil(SubXlth/Pm.UpLimit);
end
Node=zeros(NumNode,Pm.Xwd);

% RandomSize=Pm.UpLimit/2;
% for i=1:NumNode
%     NodeOri=Data(randperm(SubXlth,RandomSize),:);
%     Node(i,:)=mean(NodeOri);
% end
%[~,Node]=kmeans(Data,NumNode);
% Node=Data(randperm(SubXlth,NumNode),:);
% for i=1:10
%     MidNode=Data(randperm(SubXlth,NumNode),:);
%     for j=1:NumNode
%         [~,Winner]=min(dist(MidNode(j,:),Node'));
%         Node(Winner,:)=(Node(Winner,:)*(i-1)+MidNode(j,:))/i;
%     end
% end

% NumSib=length(NodeParentSib(:,1));
% if NumSib ==4 && isempty(NodeGrandParent)==0
%     Node(1,:)=2*NodeGrandParent-NodeParent;
%     for i=1:NumNode
%         Node(i,:)=(2*NodeGrandParent-NodeParentSib(i,:)+Node(1,:))/2;
%     end
% else
%     Node=Data(randperm(SubXlth,NumNode),:);
% end

%Node=Data(1:NumNode,:);
Node=Data(randperm(SubXlth,NumNode),:);
Converge=0;
OriError=0;
ClassLableOri=zeros(SubXlth,1);
ClassLable=zeros(SubXlth,1);
Error=zeros(NumNode,1);
WinTime=ones(NumNode,1);
TotalTime=sum(WinTime);

%% training
TrainTimes=0;
while Converge==0 
    TrainTimes=TrainTimes+1;
    %TrainTimes
    %DataTrain=Data(randperm(SubXlth,SubXlth),:);
    DataTrain=Data;
    % training
    for i=1:SubXlth
        [~,Winner]=min(dist(Node,DataTrain(i,:)'));
        WinTime(Winner)=WinTime(Winner)+1;
        TotalTime=TotalTime+1;
        LearnRate=Pm.LearnRate1*(1-WinTime(Winner)/TotalTime);
        Node(Winner,:)=Node(Winner,:)+LearnRate*(DataTrain(i,:)-Node(Winner,:));
    end
    for i=1:SubXlth
        [~,ClassLable(i)]=min(sqrt(sum((DataTrain(i,:)-Node).^2,2)));
    end
    % testing the convergence using error
    for i=1:NumNode
        Error(i,1)=sum(dist(DataTrain(ClassLable==i,:),Node(i,:)'));
    end
    if abs(mean(Error)-OriError)<Pm.ErrorBound*OriError || TrainTimes==20
        Converge=1;
    else
        OriError=mean(Error);
    end
%     % testing the convergence using class lable change
%     if ClassLable==ClassLableOri
%         Converge=1;
%     else
%         ClassLableOri=ClassLable;
%     end
end
% update the membership of this subset
CorSet=false(NumNode,Pm.Xlth);
for i=1:SubXlth
    [~,Host]=min(dist(Node,Data(i,:)'));
    CorSet(Host,DataLct(i))=1;
end
end

