
% merge the nodes in each layer from bottom to top.
% output the Links of all the nodes for further use.

function [Links] = IMergeLayer(Layer,Node,CorSet,~,Sigma)

ThisLayer=max(Layer);
while ThisLayer~=1 % merge using different linkages and different metrics
    NodeList=find(Layer==ThisLayer);
    NumNodesThisLayer=length(NodeList);
    for i=1:NumNodesThisLayer
        SubNodes=Node{NodeList(i)};
        %if LinkType==4 % potential metric
        NumSubNodes=length(SubNodes(:,1));
        SubNodesCount=zeros(1,NumSubNodes);
        for j=1:NumSubNodes
            SubNodesCount(j)=length(find(CorSet{NodeList(i)}(j,:)==1));
        end
        SubNodesFreq=SubNodesCount/sum(SubNodesCount);
        Po=zeros(j,1);
        for j=1:NumSubNodes
            DistVct=dist(Node{NodeList(i)}(j,:),Node{NodeList(i)}');
            DistVct(DistVct<Sigma)=Sigma;
            SubPoVct=SubNodesFreq.*(1./DistVct);
            Po(j)=sum(SubPoVct);
        end
        NoPoCom=[(1:NumSubNodes)',Po];
        NoPoCom=-sortrows(-NoPoCom,2);
        global DistMtx
        DistMtx=inf(NumSubNodes);
        for j=2:NumSubNodes
            DistVct=dist(Node{NodeList(i)}(NoPoCom(1:j-1,1),:),Node{NodeList(i)}(NoPoCom(j,1),:)');
            [MinDist,Winner]=min(DistVct);
            DistMtx(NoPoCom(j,1),NoPoCom(Winner,1))=MinDist;
            DistMtx(NoPoCom(Winner,1),NoPoCom(j,1))=MinDist;
        end
        MyMetric=cell(1);
        MyMetric{1}='@DenMetric'; %% change this for different metric %%
        Links{NodeList(i)}=linkage(SubNodes,'single',MyMetric); % link the child nodes of node "i" in "ThisLayer"
        %end
    end
    % rank the links of all the child nodes of the nodes in "ThisLayer"
    MergeDist=[];
    for i=1:NumNodesThisLayer
        Links{NodeList(i)}(isnan(Links{NodeList(i)}(:,3)),3)=inf;
        MergeDist=[MergeDist;Links{NodeList(i)}(:,3)];
    end
    SortDist=sort(MergeDist);
    for i=1:NumNodesThisLayer
        for j=1:length(Links{NodeList(i)}(:,1))
            RankLct=find(SortDist==Links{NodeList(i)}(j,3),1);
            SortDist(RankLct)=inf;
            Links{NodeList(i)}(j,3)=RankLct;
        end
    end
    ThisLayer=ThisLayer-1; % go to the upper layer
end
end
